%% temporary testing code for FORWARD Computation

clear;clc;close all;
load('./examples/VDSR_zy/data/Net_E20.mat');

% net=ans;
for i=1:numel(ans.layers)-1
    net.layers{1,i}=ans.layers{1,i};
end

zooming=4;

in_path='./examples/VDSR_zy/Test/Long/';
im_format='*.png';
out_path='./examples/VDSR_zy/Test/Long/';

d = fullfile(in_path, im_format);
files = dir(d);
sumPSNR=0;
sumPSNRbp=0;
for iFile=1:numel(files)
    
    
    nowfile=fullfile(in_path, files(iFile).name);
    disp(['Now testing the Image...',num2str(iFile),'/',num2str(numel(files)),'...',nowfile]);
    IMG=imread(nowfile);

    % adjusting the image size according to the magnificant factor
    if rem(size(IMG,1),zooming) ~=0,
        nrow = floor(size(IMG,1)/zooming)*zooming;
        IMG = IMG(1:nrow,:,:);
    end;
    if rem(size(IMG,2),zooming) ~=0,
        ncol = floor(size(IMG,2)/zooming)*zooming;
        IMG = IMG(:,1:ncol,:);
    end;

    % utilizing the Y-channel
    IMGycbcr=rgb2ycbcr(IMG);
    IMGy=IMGycbcr(:,:,1);
    
    IMGL=imresize(IMG,1/zooming,'bicubic');
    IMGbicubic=imresize(IMGL,zooming,'bicubic');
    IMGbicubicycbcr=rgb2ycbcr(IMGbicubic);
    IMGy_bicubic=IMGbicubicycbcr(:,:,1);
    IMGcb=IMGbicubicycbcr(:,:,2);
    IMGcr=IMGbicubicycbcr(:,:,3);
    
    

    
    IMGy_bicubic=single(IMGy_bicubic)./255;
    IMGy=single(IMGy)./255;
    
    
    %% forward

    dzdy=[];
    opts.conserveMemory = false ;
    opts.backPropDepth = +inf ;
    opts.sync = false ;
    opt.mode='test';
    opts.cudnn = false ;
    res=[];

    res = vl_simplenn(net, IMGy_bicubic, dzdy, res, ...
                          'mode', opt.mode, ...
                          'conserveMemory', opts.conserveMemory, ...
                          'backPropDepth', opts.backPropDepth, ...
                          'sync', opts.sync, ...
                          'cudnn', opts.cudnn) ;


    % residual=res(end).x;
    % IMGHy1=IMGy_bicubic(ssize+1:end-ssize,ssize+1:end-ssize)+residual;
    % IMGHy=uint8(mat2gray(IMGHy1).*255);

    % IMGHy=uint8(mat2gray(res(end).x).*255);
    % IMGHcb=IMGcb;
    % IMGHcr=IMGcr;
    %     
    % %% calculating the PSNR
    % IMGy=uint8(IMGy.*255);
    % IMGy_bicubic=uint8(IMGy_bicubic.*255);

    IMGHy=mat2gray(res(end).x).*255;
    IMGHcb=IMGcb;
    IMGHcr=IMGcr;

    %% calculating the PSNR
    IMGy=(IMGy.*255);
    IMGy_bicubic=(IMGy_bicubic.*255);

%     IMGHy=(IMGHy-mean(IMGHy(:)))/std(IMGHy(:))*std(IMGy(:))+mean(IMGy(:));
    IMGHy=(IMGHy-mean(IMGHy(:)))/std(IMGHy(:))*std(IMGy_bicubic(:))+mean(IMGy_bicubic(:));
    IMGHy=uint8(IMGHy);
    IMGy=uint8(IMGy);
    IMGy_bicubic=uint8(IMGy_bicubic);
    %     IMGHy=im2double(IMGHy);
    %     IMGHy=(IMGHy-mean(IMGHy(:)))/std(IMGHy(:))*20+128;
    %     IMGy=im2double(IMGy);
    %     IMGy=(IMGy-mean(IMGy(:)))/std(IMGy(:))*20+128;
    %     IMGy_bicubic=im2double(IMGy_bicubic);
    %     IMGy_bicubic=(IMGy_bicubic-mean(IMGy_bicubic(:)))/std(IMGy_bicubic(:))*20+128; 

%     % compute PSNR for the illuminance channel
%     bb_rmse = compute_rmse(IMGy, IMGy_bicubic);
%     sp_rmse = compute_rmse(IMGy, IMGHy);
%     bb_psnr = 20*log10(255/bb_rmse);
%     sp_psnr = 20*log10(255/sp_rmse);
%     fprintf('PSNR for Bicubic Interpolation: %f dB\n', bb_psnr);
%     fprintf('PSNR for CNN: %f dB\n', sp_psnr);
% 
%     sumPSNR=sumPSNR+sp_psnr;
%     sumPSNRbp=sumPSNRbp+bb_psnr;

    IMGH=IMGycbcr.*0;
    IMGH(:,:,1)=IMGHy;
    IMGH(:,:,2)=IMGHcb;
    IMGH(:,:,3)=IMGHcr;

    IMGH_bicubic=IMGycbcr.*0;
    IMGH_bicubic(:,:,1)=IMGy_bicubic;
    IMGH_bicubic(:,:,2)=IMGHcb;
    IMGH_bicubic(:,:,3)=IMGHcr;
    IMGH_bicubic2=ycbcr2rgb(IMGH_bicubic);


    outpath=[out_path,num2str(zooming),'x/',files(iFile).name,'_L20_E20.bmp'];
    IMGH=ycbcr2rgb(IMGH);
    imwrite(IMGH,outpath,'bmp');
    outpathb=[out_path,num2str(zooming),'x/',files(iFile).name,'bicubic.bmp'];
    imwrite(IMGH_bicubic2,outpathb,'bmp');



end

disp('===========================================================');
% disp(['Average PSNR of bicubic:',num2str(sumPSNRbp/numel(files))]);
% disp(['Average PSNR of Ours:',num2str(sumPSNR/numel(files))]);











